<?php
##############################################
##	Link Popularity Checker					##
##	Version:		1.1						##
##	Release Date:	03-06-05				##
##------------------------------------------##
##	Website:	http:/www.checkurl.info		##
##	Email:		support@checkurl.info		##
##------------------------------------------##
## Copyright 2005 by Promotion 24 LLC.		##
##############################################
// ensure this file is being included by a parent file
defined( 'P24LINKPOP' ) or die( 'Direct Access to this location is not allowed.' );

function Yahoo($domain,$settings) {
	//define vars
	$return = NULL;
	$serviceURL = 'http://api.search.yahoo.com/WebSearchService/V1/webSearch';

	// set the query
	$query = str_replace("[[FULLURL]]", $domain['fullurl'],
				str_replace("[[DOMAIN]]", $domain['domain'],
				str_replace("[[DOM]]", $domain['dom'],
				str_replace("[[EXT]]", $domain['ext'],
				$settings['apiQuery']))));

	// construct the query
	$q = '?query='.rawurlencode($query)."&adult_ok=1&similar_ok=1&appid=".$settings['apiKey'];
	
	// get the xml results
	$xml = file_get_contents($serviceURL.$q);
	
	// check via domxml or preg_match ??
	switch($settings['misc']) {
		case 'domxml':
			// Parse the XML and check it for errors
			if (!$dom = domxml_open_mem($xml,DOMXML_LOAD_PARSING,$error)) {
				// there was an XML parse error, for now just return -1 denoting an invalid result
				$return = -1;
				/*
				echo "XML parse error\n";
				foreach ($error as $errorline) {
					echo $errorline['errormessage']."<br />\n";
					echo " Node  : " . $errorline['nodename'] . "<br />\n";
					echo " Line  : " . $errorline['line'] . "<br />\n";
					echo " Column : " . $errorline['col'] . "<br />\n";
				}
				*/
			}
			// if the query was successfull and there was no error
			else {
				$root = $dom->document_element();
				$return = $root->get_attribute('totalResultsAvailable');
			}
			break;
		default:
			// Match the result
			if(!preg_match('/totalResultsAvailable=\"(\d+)\"/', $xml, $match)) {
				// return -1 denoting an invalid result
				$return = -1;
			}
			// if the query was successfull and there was no error
			else {
				$return = $match[1];
			}
			break;
	}

	// return the results
    return intval($return);
}
?>